\ ---BASIC layer for VfxForth by Petrus Prawirodidjojo---
\ include b2fv

include \progra~1\vfxeval\lib\ndp387
-short-branches
18 set-precision
: 0.0
    %0 ;
: 1.0
    %1 ;
: pi
    %pi ;
: .id
    .name ;
char . dp-char !

cr
.( ...including b2fv.fth)

\ FVARIABLE  ( "<spaces>name" -- ) name: ( -- f-addr ) 12.6.1.1630 
\     define floating-point variable

\ F@  ( f-addr -- ) ( F: -- r ) 12.6.1.1472
\     fetch fvariable

\ F!  ( f-addr -- ) ( F: r -- ) 12.6.1.1400
\     store to fvariable

\ svariable  ( u -- )
\     define counted string variable with max. length u, non standard
: svariable
    create 0 c, 0 c, allot ;	\ extra one byte for asciiz

\ s@  ( a-addr -- c-addr u )
\     fetch svariable, non standard
: s@
    count ;

\ s.  ( c-addr u -- )
\     display string, non standard
: s.
    type space ;

\ s!  ( c-addr u a-addr -- )
\     store string to a counted string variable, non standard
: s!
    2dup c! 1+ swap move ;

\ s?  ( a-addr -- )
\     fetch and display svariable, non standard
: s?
    s@ s. ;

\ VARIABLE  ( "<spaces>name" -- ) name: ( -- a-addr ) 6.1.2410
\     define integer

\ @  ( a-addr -- x ) 6.1.0650
\     fetch integer variable

\ .  ( n -- ) 6.1.0180
\     display integer number

\ !  ( x a-addr -- ) 6.1.0010
\     store to integer variable

\ ?  ( a-addr -- ) 15.6.1.0600
\     fetch and display integer variable

\ F+  ( F: r1 r2 -- r3 ) 12.6.1.1420
\     return r3 where r3 is r1+r2

\ F-  ( F: r1 r2 -- r3 ) 12.6.1.1425
\     return r3 where r3 is r1-r2

\ F*  ( F: r1 r2 -- r3 ) 12.6.1.1410
\     return r3 where r3 is r1*r2

\ F/  ( F: r1 r2 -- r3 ) 12.6.1.1430
\     return r3 where r3 is r1/r2

\ s+  ( c-addr u a-addr -- )
\     append string to a counted string variable, non standard
: s+
    2dup 2>r count + swap move 2r> +! ;

\ cs+  ( char a-addr -- )
\     append char to counted string variable, non standard
: cs+
    1 over +! dup c@ + c! ;

\ cs-  ( a-addr -- char )
\     remove last char from a counted string, non standard
: cs-
    dup c@ swap -1 over +! + c@ ;

\ +  ( n1|u1 n2|u2 -- n3|u3 ) 6.1.0120
\     return n3 where n3 is n1+n2

\ -  ( n1|u1 n2|u2 -- n3|u3 ) 6.1.0160
\     return n3 where n3 is n1-n2

\ *  ( n1|u1 n2|u2 -- n3|u3 ) 6.1.0090
\     return n3 where n3 is n1*n2

\ /  ( n1 n2 -- n3 ) 6.1.0230
\     return n3 where n3 is n1/n2

\ inputf  ( a-addr -- )
\     input floating point variable, non standard
: inputf
    pad 64 accept pad swap >float if f! else %0 f! then ;

\ inputs  ( a-addr n -- )
\     input counted string variable, non standard
: inputs
    pad swap accept pad swap rot s! ;

\ inputi  ( a-addr -- )
\     input integer variable, non standard
: inputi
    0. pad 11 accept		\ 11 for 32 bit, 6 for 16 bit
    pad swap >number 2drop drop swap ! ;

\ int>float  ( n -- ) ( F: -- r )
\     convert integer to floating-point, non standard
: int>float
    s>d d>f ;

\ float>int  ( -- n ) ( F: r -- )
\     convert floating point to integer, non standard
: float>int
    f>d d>s ;

\ float>string  ( -- c-addr u ) ( F: r -- )
\     convert floating-point to string, non standard
\	2002 by Petrus Prawirodidjojo

\ -.0trailing  ( c-addr1 u1 -- c-addr1 u2 )
\     discard trailing .000
: -.0trailing  ( c-addr1 u1 -- c-addr1 u2 )
    0 over 0 ?do
      2 pick i + c@
      over 0= if
        [char] . = if drop i then
      else
        [char] 0 = 0= if drop i 1+ then
        then
      loop
    dup 0= if drop else swap drop then ;

34 svariable b2fspc	\ max 27 characters

: float>string
    [ 18 2 + ] literal b2fspc c!
    b2fspc 3 + 18 represent if
      if [char] - else bl then b2fspc 1+ c!
      dup 18 > over -5 < or if
        b2fspc 3 + c@ b2fspc 2 + c!
        [char] . b2fspc 3 + c!
        b2fspc s@ -.0trailing swap drop b2fspc c!
        [char] E b2fspc cs+
        1- dup 0< if [char] - else [char] + then >r
        abs s>d <# # # # #s r> hold #> b2fspc s+
      else
        dup 0 > if
          dup 1- 3 /
          dup 20 + b2fspc c!
          over b2fspc + 3 + over over +
          over over 18 6 pick - move
          2 pick 0 ?do
            over i 1+ 3 * -
            over i 1+ 3 * - i 1+ -
            dup >r 3 move r>
            i 0= if drop else [char] , swap 3 + c! then
            loop
          b2fspc 3 + dup 1-
          5 pick 3 mod dup 0= if 3 + then move
          2 pick 0= 0= if 3 pick 3 mod dup 0= if 3 + then
            b2fspc 2 + + [char] , swap c! then
          [char] . swap 1- c!
          drop 2drop
        else
          abs dup 21 + b2fspc c!
          b2fspc 3 + over 4 + b2fspc + 18 move
          [char] 0 b2fspc 2 + c!
          [char] . b2fspc 3 + c!
          0 ?do [char] 0 b2fspc i + 4 + c! loop
          then
        b2fspc s@ -.0trailing swap drop b2fspc c!
        then
    else
      18 b2fspc c! b2fspc 3 + b2fspc 1+ 18 move
      2drop then
    b2fspc s@ ;

\ F.  ( F: r -- ) 12.6.2.1427
\     display floating-point number
: f.
    float>string type space ;

\ f?  ( f-addr -- )
\     fetch and display fvariable, non standard
: f?
    f@ f. ;

\ string>float  ( c-addr u -- ) ( F: -- r )
\     convert string to floating-point, non standard
: string>float
    >float 0= if %0 then ;

\ F<  ( -- flag ) ( F: r1 r2 -- ) 12.6.1.1460
\     return true if r1 is less than r2

\ f=  ( -- flag ) ( F: r1 r2 -- )
\     return true if r1 equal r2, non standard

\ f>  ( -- flag ) ( F: r1 r2 -- )
\     return true if r1 is greater than r2, non standard

\ f<=  ( -- flag ) ( F: r1 r2 -- )
\     return true if r1 is less or equal than r2, non standard

\ f<>  ( -- flag ) ( F: r1 r2 -- )
\     return true if r1 not equal to r2, non standard

\ f>=  ( -- flag ) ( F: r1 r2 -- )
\     return true if r1 is greater or equal than r2, non standard

\ s<  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 before s2, non standard
: s<
    compare -1 = ;

\ s=  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 = s2, non standard
: s=
    compare 0= ;

\ s>  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 after s2, non standard
: s>
    compare 1 = ;

\ s<=  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 before or equal s2, non standard
: s<=
    s> 0= ;

\ s<>  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 not equal to s2, non standard
: s<>
    s= 0= ;

\ s>=  ( c-addr1 u1 c-addr2 u2 -- flag )
\     return true if s1 after or equal s2, non standard
: s>=
    s< 0= ;

\ <  ( n1 n2 -- flag ) 6.1.0480
\     return true if n1 less than n2

\ =  ( x1 x2 -- flag ) 6.1.0530
\     return true if x1 equal x2

\ >  ( n1 n2 -- flag ) 6.1.0540
\     return true if n1 greater than n2

\ <=  ( n1 n2 -- flag )
\     return true if n1 less than or equal n2, non standard

\ <>  ( n1 n2 -- flag )
\     return true if n1 not equal n2, non standard

\ >=  ( n1 n2 -- flag )
\     return true if n1 greater than or equal n2, non standard

\ dataptr
\     data pointer variable, non standard
variable dataptr

\ newdata  ( "<spaces>name" -- )
\     start a new data set, non standard
: newdata
    create does> dataptr ! ;

\ f,  ( F: r -- )
\     store r in code area, non standard

\ s,  ( c-addr u -- )
\     store string in code area as counted string, non standard
: s,
    here over 1+ allot s! ;

\ i,  ( n -- )
\     store integer in code area, non standard
: i,
    here 4 allot ! ;		\ 4 for 32 bit, 2 for 16 bit

\ readf  ( F: -- r )
\     read floating point from code area, non standard
: readf
    dataptr @ f@ 10 dataptr +! ;	\ 10, 8 or 4

\ reads  ( -- c-addr u )
\     read string from code area, non standard
: reads
    dataptr @ count dup 1+ dataptr +! ;

\ readi  ( -- x )
\     read integer from code area, non standard
: readi
    dataptr @ @ 4 dataptr +! ;	\ 4 for 32bit or 2 for 16bit

\ CR  ( -- ) 6.1.0990
\     newline

\ fload  ( "<spaces>name" -- )
\     load source file, non standard
: fload
    bl word count included ;

\ fsave  ( "<spaces>name" -- )
\     save new system, non standard

\ mainword  ( "<spaces>name" -- )
\     execute name when run, non standard

\ turnkey  ( "<spaces>name" -- )
\     save application, set mainword first, non standard

\ BYE  ( -- ) 15.6.2.0830
\     exit from Forth

\	fsave b2f.exe		\ save with dictionary

cr cr unused u. .( bytes free. )
\	bye
\	end of application, - do not delete -